import Control.Exception
import Control.Concurrent

-- Running this shows how exceptions can be caught
catchit :: IO ()
catchit = 
  catch (putStrLn $  error "FOO!")
        (\e-> putStrLn $ "An error has been caught: "++ show (e:: ErrorCall))

-- Running this shows exceptions being raised in concurrent threads
nocatch :: IO ()
nocatch = forkIO (error "FOO!") >> return ()

main :: IO ()
main = 
  catch (do
     m <- newEmptyMVar
     forkIO (takeMVar (m :: MVar String) >>= putStrLn. show)
     threadDelay (100000)
     putMVar m (error "FOO!"))
   (\e-> putStrLn $ "An error has occured: "++ show (e:: ErrorCall))

