package robots {

import scala.util.{Try,Success,Failure}
import scala.concurrent.{Future,Promise}
import scala.concurrent.ExecutionContext.Implicits.global
import scala.util.Random

case class LowBatteryException() extends Exception("Low Battery")

case class Robot(id: Int, pos: Int, battery: Int) {
  private def mv(n: Int): Robot = 
    if (n <= 0) this
    else if (battery > 0) {
      Thread.sleep(100*Random.nextInt(10));
      Robot(id, pos+1, battery- 1).mv(n-1)
    } else throw new LowBatteryException

  def move(n: Int): Future[Robot] = Future { mv(n) }

  def move2(n: Int, p: Promise[Robot])= p complete Try(mv(n))

  override def toString = s"Robot #$id at $pos [battery: $battery]"
}

}

