module Robots2 where

import Control.Concurrent
import System.Random

data Robot = Robot {id :: Int, pos :: Int, battery :: Int}

instance Show Robot where
  show (Robot i p b) = "Robot #"++ show i++ " at "++ show p++ " [battery: "++ show b++ "]"


move :: Robot-> Int-> IO (MVar Robot)
move r n = do
  m <- newEmptyMVar; forkIO (mv m r n); return m

mv :: MVar Robot -> Robot-> Int-> IO ()
mv v r n 
  | n <= 0 = putMVar v r
  | otherwise =  do
    m<- randomRIO(0,10); threadDelay(m*100000)
    mv v r{pos= pos r+ 1, battery= battery r- 1} (n-1)

ex :: IO ()
ex = do
  let swarm = [Robot i 0 10 | i<- [1..6]]
  mvs <- mapM (\r-> move r 5) swarm
  mapM_ (\v-> forkIO (takeMVar v >>= putStrLn. show)) mvs
  putStrLn "Started moving robots..."
